using System;

class Program
{
    static void Main()
    {
        string[] nIp = Console.ReadLine().Split();
        int n = int.Parse(nIp[0]);
        int p = int.Parse(nIp[1]);
        int[,] matrica = new int[n, 2];
        long[] pitanja = new long[p];
        long[] rezultati = new long[p];
        for (int i = 0; i < n; i++)
        {
            string[] matricaUnos = Console.ReadLine().Split();
            matrica[i, 0] = int.Parse(matricaUnos[0]);
            matrica[i, 1] = int.Parse(matricaUnos[1]);
        }
        for (int i = 0; i < p; i++)
        {
            pitanja[i] = long.Parse(Console.ReadLine());
        }
        for (int i = 0; i < p; i++)
        {
            for (int j = 0; j < n; j++)
            {
                if (pitanja[i] >= matrica[j, 0])
                {
                    if (pitanja[i] < matrica[j, 1])
                    {
                        rezultati[i] += matrica[j, 1] - pitanja[i];
                    }
                    else if (j < n - 1 && pitanja[i] > matrica[j, 1] && pitanja[i] < matrica[j + 1, 0] - matrica[j, 0])
                    {
                        rezultati[i] += pitanja[i] - matrica[j, 0] + 1;
                    }
                    else
                    {
                        rezultati[i] += matrica[j, 1];
                    }
                }
            }
        }
        foreach (long rezultat in rezultati)
        {
            Console.WriteLine(rezultat);
        }
        Console.ReadKey();
    }
}